@echo off

set problem=blackboard
set author=gs
rem you can set lang as dpr, java, cpp or python
set lang=cpp

echo Generating tests...
cd src
if exist TestGen.py python TestGen.py
if exist TestGen.java javac TestGen.java
if exist TestGen.class java TestGen
cd ..

echo Compiling checker...

if exist check.dpr dcc32 -U..\..\..\lib -cc check.dpr
if exist Check.java javac -classpath ../../../lib/testlib4j.jar Check.java -encoding utf8 
if exist Check.class jar cf Check.jar *.class

if not exist Validate.java goto novalidate

echo Compiling validator...

rmdir /S /Q __tmp 2> nul
mkdir __tmp
javac -sourcepath . -d __tmp Validate.java
pushd __tmp
mkdir META-INF
echo Main-Class: Validate> META-INF/manifest.1
call jar cfm validate.jar META-INF/manifest.1 *.class
copy /Y validate.jar .. > nul
popd
rmdir /S /Q __tmp

:novalidate

echo Generating answers...

if [%lang%]==[java] javac %problem%_%author%.java -encoding utf8
if [%lang%]==[cpp] g++ %problem%_%author%.cpp -O2 -Wall -Wl,--stack=67108864 -o %problem%_%author%.exe
if [%lang%]==[dpr] dcc32 -cc %problem%_%author%.dpr

rem you can add tests folders here. For example: for %%s in (preliminary, tests, tests\subtask1, tests\subtask2)
for %%s in (preliminary, tests) do ( 
    for %%i in (%%s\??) do (
        echo Test %%i
        copy %%i %problem%.in > nul
        if exist validate.jar (
            java -jar validate.jar < %problem%.in
            if errorlevel 1 (
                echo Validator rejects test %%i
                goto end
            )
            echo Validator accepts test %%i
        )

        if [%lang%]==[java] java %problem%_%author%
        if [%lang%]==[cpp] %problem%_%author%.exe
        if [%lang%]==[dpr] %problem%_%author%.exe
        if [%lang%]==[python] python %problem%_%author%.py

        copy %problem%.out %%i.a > nul
        echo Check %%i
        if exist check.exe check %%i %%i.a %%i.a
        if exist Check.class java -Xmx256M -Xss64M -cp ../../../lib/testlib4j.jar;. ru.ifmo.testlib.CheckerFramework Check %%i %%i.a %%i.a
    )
)

:end