#include <bits/stdc++.h>

const int maxPrimes = 1230;
const int maxnum = 10000 + 100;
const int mod = 1e9 + 7;

int sizePrimes = 0;
std::pair <int, int> primes[maxPrimes];

void factorize(int x) {
    sizePrimes = 0;
    for (int i = 2; i * i <= x; i++) {
        int power = 0;
        while (x % i == 0)
            ++power, x /= i;
        if (power > 0)
            primes[sizePrimes++] = std::make_pair(i, power);
    }
    if (x > 1)
        primes[sizePrimes++] = std::make_pair(x, 1);
}

int id[maxnum];

bool isPrime(int x) {
    for (int i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}

void precalcPrimePowers() {
    int primes = 0;
    for (int i = 1; i < maxnum; i++) {
        if (i > 1 && isPrime(i))
            id[i] = primes++;
    }
}                

struct FenwickTree {
    std::vector <int> t;
    int n;

    FenwickTree() {t.clear(), n = 0;}
    FenwickTree(int _n) {      
        n = _n;
        t.resize(n + 1);
    }

    void update(int v, int x) {
        for (int i = v + 1; i <= n; i += (i & (-i)))
            t[i] += x;
    }

    int get(int v) {
        int ans = 0;
        for (int i = v + 1; i > 0; i -= (i & (-i)))
            ans += t[i];
        return ans;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
} tree[maxPrimes];

int main() {
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    precalcPrimePowers();
    int n;
    scanf("%d", &n);
    for (int i = 0; i < maxPrimes; i++)
        tree[i] = FenwickTree(n);
    std::vector <int> as(n);
    for (int i = 0; i < n; i++) {
        int x;
        scanf("%d", &x);
        as[i] = x;
        factorize(x);
        for (int it = 0; it < sizePrimes; it++) {
            int prime = primes[it].first;
            int power = primes[it].second;
            tree[id[prime]].update(i, power);
        }
    }
    int q;
    scanf("%d", &q);
    for (int it = 0; it < q; it++) {
        int type;
        scanf("%d", &type);
        if (type == 0) {
            int pos, value;
            scanf("%d%d", &pos, &value);
            --pos;
            factorize(as[pos]);
            for (int i = 0; i < sizePrimes; i++) {
                int prime = primes[i].first;
                int power = primes[i].second;
                tree[id[prime]].update(pos, -power);
            }
            factorize(value);
            for (int i = 0; i < sizePrimes; i++) {
                int prime = primes[i].first;
                int power = primes[i].second;
                tree[id[prime]].update(pos, power);
            }
            as[pos] = value;
        } else {
            int l, r;
            scanf("%d%d", &l, &r);
            --l, --r;

            long long ans = 1;
            for (int i = 0; i < maxPrimes; i++)
                ans = (ans * (tree[i].get(l, r) + 1)) % mod;
            printf("%I64d\n", ans);
        }
    }                                   
    fprintf(stderr, "%.5lf\n", double(clock()) / CLOCKS_PER_SEC);
    return 0;
}
                    