/**
 * Created by GShark on 24.10.2014.
 */
import java.io.*;
import java.util.*;

public class TestGen {
    public static void main(String[] args) throws IOException {
        new TestGen().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    int tNumber;
    Random rnd;
    final int MAXN = 100_000;
    final int MAXX = 1_000_000_000;
    ArrayList<Integer> test;

    int rand(int n) {
        return rnd.nextInt(n);
    }

    void print(ArrayList<Integer> al) throws IOException {
        System.err.println(tNumber);
        if (tNumber < 10) {
            out = new PrintWriter("../tests/0" + tNumber);
        } else {
            out = new PrintWriter("../tests/" + tNumber);
        }
        tNumber++;
        out.println(al.size());
        for (int i = 0; i < al.size() - 1; i++)
            out.print(al.get(i) + " ");
        out.println(al.get(al.size() - 1));
        al.clear();
        out.close();
    }


    // here starts gens

    void genSample1() throws IOException {
        test.add(1);
        test.add(2);
        test.add(3);
        print(test);
    }

    void genSample2() throws IOException {
        test.add(20);
        test.add(17);
        test.add(18);
        test.add(2);
        print(test);
    }

    void genSimple1() throws IOException {
        test.add(5);
        test.add(50);
        test.add(55);
        test.add(57);
        test.add(505);
        test.add(506);
        test.add(59);
        test.add(6);
        test.add(575);
        print(test);
    }

    int genRandNum(int len, int pref) {
        int l = 0;
        int tmp = pref;
        do {
            l++;
            tmp /= 10;
        } while (tmp > 0);
        int suf = 0;
        if (len == l) {
            return -1;
        }
        int lenSuf = rand(len - l) + 1;
        int q = 1;
        for (int i = 0; i < lenSuf; i++) {
            suf = suf * 10 + rand(10);
            q *= 10;
        }
        return pref * q + suf;
    }

    void genRand(int maxn, int maxx) throws IOException {
        int n = maxn / 2 + 1 + rand(maxn / 2);
        for (int i = 0; i < n; i++) {
            test.add(rand(maxx + 1));
        }
        print(test);
    }

    void gen(int n, int pref, int len, int level)
    {
        assert(pref < MAXX);
        if (rand(4) == 0) {
            test.add(pref);
        }
        if (n >= test.size()) {
            return;
        }
        int k = rand(n - test.size());
        for (int i = 0; i < k; i++) {
            int x = genRandNum(len, pref);
            if (x == -1) {
                return;
            }
            gen(n, x, len, level + 1);
        }
    }

    void genSpecial(int n, int maxLen) throws IOException {
        int maxx = 1;
        for (int i = 0; i < maxLen; i++) {
            maxx *= 10;
        }
        while (test.size() < n)
        {
            int pref = rand(maxx);
            gen(n, pref, maxLen, 0);
        }
        print(test);
    }

    void genBest(int n, int maxx) throws IOException {
        test.add(rand(maxx + 1));
        while (test.size() < n) {
            int k = rand(test.size());
            long q = (long)test.get(k) * 10 + rand(10);
            if (q <= maxx) {
                test.add((int)q);
            } else {
                test.add(rand(maxx + 1));
            }
        }
        print(test);
    }

    void genSame(int n) throws IOException {
        for (int i = 0; i < n; i++) {
            test.add(i % 100);
        }
        print(test);
    }

    //the end of the gens

    public void generate() throws IOException {
        new File("../tests").mkdir();
        tNumber = 1;
        rnd = new Random(388282447);
        test = new ArrayList<Integer>();
        genSample1();
        genSample2();
        genSimple1();
        for (int i = 1; i < 10; i++) {
            genBest(rand(MAXN - 10) + 10, i*i*i*i*i*i*i*i + 10);
            genRand(rand(MAXN - 10) + 10, i*i*i*i*i*i*i*i*i);
            genSpecial(rand(MAXN - 10) + 10, i);
        }
        genSame(MAXN);
        for (int i = 0; i < 3; i++) {
            genRand(MAXN, MAXX);
            genBest(MAXN, MAXX);
            genSpecial(MAXN, 9);
        }
    }

    public void run() throws IOException {
        Locale.setDefault(Locale.US);
        generate();
    }
}
